function getContentBrowser(){
  var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
  var topWindowOfType = windowMediator.getMostRecentWindow("navigator:browser");
  if(topWindowOfType) return topWindowOfType.document.getElementById("content");
  return null;
}

function tabloc_href(evt){
  if(!evt.target){ return; }
  var ahref = evt.target.href;
  if(!ahref){ return; }
  var contentBrowser = getContentBrowser();
  if(!contentBrowser){ return; }
  contentBrowser.addTab(ahref);
  evt.preventDefault();
}

function tabloc_setBlankTarget(contentDocument, tagName){
  var alist = contentDocument.getElementsByTagName(tagName);
  for(i=0; i<alist.length; i++){
    var a = alist.item(i);
    var ahref = a.href;
    if(a.hasAttribute("__tabloc_target")){
      a.target = a.getAttribute("__tabloc_target");
      a.removeAttribute("__tabloc_target");
      if(ahref){ a.removeEventListener("click", tabloc_href, true); }
    }else{
      a.setAttribute("__tabloc_target", a.target);
      a.target = "_blank";
      if(ahref){ a.addEventListener("click", tabloc_href, true); }
    }
  }
}

function tabloc_execute(){
  var contentBrowser = getContentBrowser();
  if(!contentBrowser){ return; }
  var browser = contentBrowser.selectedBrowser;
  if(!browser){ return; }
  var contentDocument = browser.contentDocument;
  if(!contentDocument){ return; }
  tabloc_setBlankTarget(contentDocument, "a");
  tabloc_setBlankTarget(contentDocument, "form");
  tabloc_setBlankTarget(contentDocument, "link");
  tabloc_setBlankTarget(contentDocument, "area");
  var tab = contentBrowser.selectedTab;
  if(tab.hasAttribute("__tabloc_image")){
    tab.setAttribute("image", tab.getAttribute("__tabloc_image"));
    tab.removeAttribute("__tabloc_image");
  }else{
    tab.setAttribute("__tabloc_image", tab.getAttribute("image"));
    tab.setAttribute("image", "chrome://tabloc/content/pin.png");
  }
}

function tabloc_addMenuItem () {
  var contentBrowser = getContentBrowser();
  if(!contentBrowser){ return; }
  var tabLockMenu = document.getElementById("tablocmenu").cloneNode(false);
  if(!tabLockMenu){ return; }

  tabLockMenu.id = "tab-tabloc";
  contentBrowser.mStrip.firstChild.nextSibling.insertBefore(tabLockMenu,
     contentBrowser.mStrip.firstChild.nextSibling.childNodes[2]);

  contentBrowser.tabContainer.addEventListener("dblclick", tabloc_execute, false);
}
